<?
  # Copyright : voir fichier license.txt
  # Fichier des fonctions  
  define("FORM_BASE",
    "<form action=\"https://%s%spaiement.cgi\"
    method=\"post\" name=\"PaymentRequest\" target=\"_top\">
    <input type=\"hidden\" name=\"version\"        value=\"%s\">
    <input type=\"hidden\" name=\"TPE\"            value=\"%s\">
    <input type=\"hidden\" name=\"date\"           value=\"%s\">
    <input type=\"hidden\" name=\"montant\"        value=\"%s%s\">
    <input type=\"hidden\" name=\"reference\"      value=\"%s\">
    <input type=\"hidden\" name=\"MAC\"            value=\"%s\">
    <input type=\"hidden\" name=\"url_retour\"     value=\"%s%s\">
    <input type=\"hidden\" name=\"url_retour_ok\"  value=\"%s%s\">
    <input type=\"hidden\" name=\"url_retour_err\" value=\"%s%s\">
    <input type=\"hidden\" name=\"lgue\"           value=\"%s\">
    <input type=\"hidden\" name=\"societe\"        value=\"%s\">
    <input type=\"hidden\" name=\"texte-libre\"    value=\"%s\">
    <input type=\"submit\" name=\"bouton\"         value=\"%s\">
  </form>");
  
  // function hmac
  //
  // IN:  TPE virtuel
  //      Chaine de donnes
  // OUT: Chaine HMAC
  function hmac($Vtpe, $data="") {
    require("passe.php");
    $k1 = pack("H*",sha1($pass));
    $l1 = strlen($k1);
    $k2 = pack("H*",$Vtpe['key']);
    $l2 = strlen($k2);
    if ($l1 > $l2):
        $k2 = str_pad($k2, $l1, chr(0x00));
    elseif ($l2 > $l1):
        $k1 = str_pad($k1, $l2, chr(0x00));
    endif;
    if ($data==""):
        $d = "CtlHmac" . CMCIC_VERSION . $Vtpe['tpe'];
    else:
        $d = $data;
    endif;
    return strtolower(hmac_sha1($k1 ^ $k2, $d)); // ^ veut dire XOR
  }

  // function hmac_sha1
  //
  // IN:  Cl  hacher
  //      Chaine de donnes
  // OUT: SHA1
  function hmac_sha1 ($key, $data) {
    $length = 64; // block length for SHA1
    if (strlen($key) > $length) { $key = pack("H*",sha1($key)); }
    $key  = str_pad($key, $length, chr(0x00));
    $ipad = str_pad('', $length, chr(0x36));
    $opad = str_pad('', $length, chr(0x5c));
    $k_ipad = $key ^ $ipad ;
    $k_opad = $key ^ $opad;
    return sha1($k_opad  . pack("H*",sha1($k_ipad . $data)));
  }
  
  // function HtmlEncode
  //
  // IN:  Chaine a encoder
  // OUT: Chaine avec encodage des caractres speciaux au format HTML
  function HtmlEncode ($data) {
    $SAFE_OUT_CHARS = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890._-";
    $encoded_data = "";
    $result = "";
    for ($i =0; $i < strlen($data); $i++) {
      if (strchr($SAFE_OUT_CHARS, $data{$i})) 
        $result = $result . $data{$i};
      else
        if (($var = bin2hex(substr($data,$i,1))) <= "7F")
          $result = $result . "&#x" . $var . ";";
        else
          $result = $result . $data{$i};
    }
    return $result;
  }

  // function CreerFormulaireHmac
  //
  // IN: Numro de TPE
  //     Rfrence commande
  //     Code langue
  //     Code socit
  //     Montant
  //     Devise
  //     Texte libre
  //     Texte du bouton
  // OUT: Chaine HTML reprsentant le formulaire de paiement
  function CreerFormulaireHmac($Vtpe, $Amount, $Currency, $Order_Reference, $Order_Comment, $Language_Code, $Merchant_Code, $Button_Text) {
    // Prparation du lien de retour. Un contexte est ajout au lien.
    $Return_Context = "?order_ref=".$Order_Reference;
    if ($Order_Comment == "") $Order_Comment = "-";
    $Order_Date = date("d/m/Y:H:i:s");
    $Language_2 = substr($Language_Code, 0, 2);
    $keyedMAC = hmac($Vtpe, $Vtpe["tpe"] . "*" . $Order_Date . "*" . $Amount . $Currency . "*" . $Order_Reference . "*" .
                            $Order_Comment . "*" . CMCIC_VERSION . "*" . $Language_2 . "*" . $Merchant_Code . "*");
    return sprintf(FORM_BASE, HtmlEncode( CMCIC_SERVER ), HtmlEncode( CMCIC_DIR ), HtmlEncode( CMCIC_VERSION ),  HtmlEncode( $Vtpe["tpe"] ),
                              HtmlEncode( $Order_Date ), HtmlEncode( $Amount ), HtmlEncode( $Currency ), HtmlEncode( $Order_Reference ),
                              HtmlEncode( $keyedMAC ), HtmlEncode( $Vtpe["retouraccueil"] ), HtmlEncode( $Return_Context ), HtmlEncode( $Vtpe["retourok"] ), 
                              HtmlEncode( $Return_Context ), HtmlEncode( $Vtpe['retourko'] ), HtmlEncode( $Return_Context ), HtmlEncode( $Language_2 ), 
                              HtmlEncode( $Merchant_Code ), HtmlEncode( $Order_Comment), HtmlEncode( $Button_Text ));
  }
  
  // function TesterHmac
  //
  // IN:  Paramtres du Tpe
  //      Champs du formulaire
  // OUT: Rsultat vrification du MAC et prparation de la rponse
  // ----------------------------------------------------------------------------
  function TesterHmac($Vtpe, $BruteVars ) {
    @$MyFields = $BruteVars['retourPLUS'] . $Vtpe["tpe"] . "+" . $BruteVars["date"] . "+" . $BruteVars['montant'] . "+" . 
      $BruteVars['reference'] . "+" . $BruteVars['texte-libre'] . "+" . CMCIC_VERSION . "+" . $BruteVars['code-retour'] . "+";
    if ( strtolower($BruteVars['MAC'] ) == hmac($Vtpe, $MyFields) ) {
      $result  = $BruteVars['code-retour'] . $BruteVars['retourPLUS'];
      $receipt = CMCIC_MACOK;
    } else { 
        $result  = 'None';
        $receipt = CMCIC_MACNOTOK . $MyFields;
    }
    $len_montant = strlen($BruteVars['montant'] ) - 3;
    if ($len_montant > 0) {
      $currency = substr($BruteVars['montant'], $len_montant, 3);
      $amount   = substr($BruteVars['montant'], 0, $len_montant);
    } else {
      $currency = "";
      $amount   = $BruteVars['montant'];
    }
    return array( "resultatVerifie" => $result , "accuseReception" => $receipt ,
                  "tpe" => $BruteVars['TPE'],"reference" => $BruteVars['reference'],
                  "texteLibre" => $BruteVars['texte-libre'], "devise" => $currency, "montant" => $amount);
  }
?>
